// Copyright 2019 Robert W Johnstone
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include "html.hpp"
#include "cmark.hpp"
#include "lexer.hpp"
#include "string.hpp"
#include <cmark-gfm.h>
#include <iostream>

cxxdoc::HTMLDriver::HTMLDriver( llvm::StringRef outputDir )
    : FormatDriver( outputDir, ".html" )
{
	// We want access to the GFM extensions to commonmark.
	cmark_gfm_core_extensions_ensure_registered();
}

static bool requiresEscape( llvm::StringRef s )
{
	for ( auto c : s ) {
		if ( c == '<' || c == '>' || c == '&' ) {
			return true;
		}
	}
	return false;
}

llvm::StringRef cxxdoc::HTMLDriver::escape( llvm::SmallVectorImpl<char>& buffer,
                                            llvm::StringRef text )
{
	// Avoid performing the escape if possible.
	// Most strings are not expected to contain characters requiring escape.
	if ( !requiresEscape( text ) ) {
		return text;
	}

	for ( auto c : text ) {
		switch ( c ) {
		case '<':
			buffer.append( {'&', 'l', 't', ';'} );
			break;
		case '>':
			buffer.append( {'&', 'g', 't', ';'} );
			break;
		case '&':
			buffer.append( {'&', 'a', 'm', 'p', ';'} );
			break;
		default:
			buffer.push_back( c );
			break;
		}
	}

	return {buffer.data(), buffer.size()};
}

void cxxdoc::HTMLDriver::prefix( ostream& out, StringRef title ) const
{
	out << "<!doctype html>\n"
	       "<html>\n"
	       "<head>\n"
	       "<meta charset=\"utf-8\">\n"
	       "<title>" << title << "</title>\n"
	       "<link rel=\"stylesheet\" "
	       "href=\"https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/"
	       "bootstrap.min.css\" "
	       "integrity=\"sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/"
	       "iJTQUOhcWr7x9JvoRxT2MZw1T\" crossorigin=\"anonymous\">\n"
	       "<style>\n"
	       ".container { max-width: 70em; }\n"
	       "pre { padding: 0.5em; word-wrap: break-word; background-color: "
	       "#f8f8f8;border: 1px solid #ccc; border-radius: 0.25em; }\n"
	       "footer { background-color: #f8f8f8; border-top: 1px solid #ccc; "
	       "padding: 1em 0; margin-top: 2em; }\n"
	       "</style>\n"
	       "<link rel=\"generator\" "
	       "href=\"https://gitlab.com/stone.code/cxxdoc\">\n"
	       "</head>\n"
	       "<body><div class=\"container\">\n";
}

void cxxdoc::HTMLDriver::suffix( ostream& out ) const
{
	out << "</div>\n"
	       "<footer>"
	       "<div class=\"container\">Generated by <a "
	       "href=\"https://gitlab.com/stone.code/cxxdoc\">CXXDoc</a>.</div>"
	       "</footer>\n"
	       "</body>\n"
	       "</html>";
}

void cxxdoc::HTMLDriver::breadcrumb( ostream& out, StringRef qname ) const
{
	auto begin = 0;
	auto end = qname.find( "::" );
	if ( end == StringRef::npos ) {
		return;
	}

	out << "<nav aria-label=\"breadcrumb\">"
	       "<ol class=\"breadcrumb\">\n";
	do {
		std::string filename = qname.substr( 0, end );
		std::replace( filename.begin(), filename.end(), ':', '_' );

		out << "<li class=\"breadcrumb-item\"><a href=\"" << filename
		    << ".html\">" << qname.substr( begin, end - begin )
		    << "</a></li>\n";
		begin = end + 2;
		end = qname.find( "::", begin );
	} while ( end != StringRef::npos );

	out << "<li class=\"breadcrumb-item active\" aria-current=\"page\">"
	    << qname.substr( begin )
	    << "</li>\n"
	       "</ol></nav>\n";
}

static struct {
	char const* const start;
	char const* const end;
} const elems[] = {{"<h1>", "</h1>\n"}, {"<h2>", "</h2>\n"},
                   {"<h3>", "</h3>\n"}, {"<p>", "</p>\n"},
                   {"<th>", "</th>"},   {"<td>", "</td>"}};

template <int I>
static void writeBlock( llvm::raw_ostream& out, llvm::StringRef text )
{
	llvm::SmallVector<char, 256> buffer;
	out << elems[I].start << cxxdoc::HTMLDriver::escape( buffer, text )
	    << elems[I].end;
}

void cxxdoc::HTMLDriver::h1( ostream& out, llvm::StringRef text ) const
{
	writeBlock<0>( out, text );
}

void cxxdoc::HTMLDriver::h2( ostream& out, llvm::StringRef text ) const
{
	writeBlock<1>( out, text );
}

void cxxdoc::HTMLDriver::h3( ostream& out, llvm::StringRef text ) const
{
	writeBlock<2>( out, text );
}

void cxxdoc::HTMLDriver::paragraph( ostream& out, llvm::StringRef text ) const
{
	writeBlock<3>( out, text );
}

void cxxdoc::HTMLDriver::documentation( ostream& out,
                                        llvm::StringRef text ) const
{
	// Build the parser.
	auto parser = getCommonMarkParser( CMARK_OPT_DEFAULT | CMARK_OPT_SMART );
	assert( parser.get() );

	// Parse and and build the AST.
	cmark_parser_feed( parser.get(), text.data(), text.size() );
	auto node = std::unique_ptr<cmark_node, cmark::node_deleter>(
	    cmark_parser_finish( parser.get() ) );
	assert( node.get() &&
	        cmark_node_get_type( node.get() ) == CMARK_NODE_DOCUMENT );

	// Render the HTML, and perform fixups.
	auto html = cmark_render_html( node.get(), CMARK_OPT_SAFE, nullptr );
	assert( html );
	lexer lexer( html );
	for ( auto token = lexer.next(); token != lexer.token_eof;
	      token = lexer.next() ) {
		switch ( token ) {
		default:
			assert( token == lexer.token_text );
			out.write( lexer.token_str().data(), lexer.token_str().size() );
			break;

		case lexer.token_blockquote:
			out.write( lexer.token_str().data(), lexer.token_str().size() );
			out << " class=\"blockquote\"";
			break;

		case lexer.token_table:
			out.write( lexer.token_str().data(), lexer.token_str().size() );
			out << " class=\"table table-bordered\"";
			break;

		case lexer.token_thead:
			out.write( lexer.token_str().data(), lexer.token_str().size() );
			out << " class=\"thead-light\"";
			break;
		}
	}
	free( html );
}

void cxxdoc::HTMLDriver::ul( ostream& out ) const
{
	out << "<ul>\n";
}

void cxxdoc::HTMLDriver::li( ostream& out,
                             llvm::StringRef name,
                             llvm::StringRef link,
                             llvm::StringRef summary ) const
{
	out << "<li>";

	if ( link.empty() ) {
		out << name;
	} else {
		out << "<a href=\"" << link << ".html\">" << name << "</a>";
	}
	if ( !summary.empty() ) {
		llvm::SmallVector<char, 256> buffer;
		out << ": " << escape( buffer, summary );
	}
	out << "</li>\n";
}

void cxxdoc::HTMLDriver::endul( ostream& out ) const
{
	out << "</ul>\n";
}

void cxxdoc::HTMLDriver::startcode( ostream& out ) const
{
	out << "<pre><code>";
}

void cxxdoc::HTMLDriver::code( ostream& out, llvm::StringRef text ) const
{
	llvm::SmallVector<char, 256> buffer;
	out << escape( buffer, text ) << '\n';
}

void cxxdoc::HTMLDriver::endcode( ostream& out ) const
{
	out << "</code></pre>\n";
}

void cxxdoc::HTMLDriver::definition( ostream& out,
                                     StringRef basename,
                                     unsigned lineNumber,
                                     StringRef link ) const
{
	out << "<p>Definition at line <a href=\"" << link << "\">" << lineNumber
	    << " of " << basename << "</a>.</p>\n";
}
